<?php

require_once(DOKU_PLUGIN.'syntax.php');
require_once(DOKU_INC.'inc/html.php');

/**
* All DokuWiki plugins to extend the parser/rendering mechanism
* need to inherit from this class
*/
class syntax_plugin_top10 extends DokuWiki_Syntax_Plugin {
	
	/**
	* return some info
	*/
	function getInfo(){
		return array(
			'author' => 'Klever Ramon',
			'email'  => 'kircsoft@gmail.com',
			'date'   => '12/06/2008',
			'name'   => 'Top 10 Plugin',
			'desc'   => 'Add the Top 10 most viewed pages on DokuWiki',
			'url'    => 'http://kircsoft.110mb.com/?id=top10',
		);
	}
	
	/**
	* What kind of syntax are we?
	*/
	function getType(){
		return 'substition';
	}
	
	/**
	* Where to sort in?
	*/
	function getSort(){
		return 105;
	}
	
	/**
	* Connect pattern to lexer
	*/
	function connectTo($mode) {
		$this->Lexer->addSpecialPattern("{{top10>.*?}}",$mode,'plugin_top10');
	}
	
	/**
	* Handle the match
	*/
	function handle($match, $state, $pos, &$handler){
		$init_pos  = strpos($match, ">");
		$pre_match = substr($match, $init_pos+1);
		$len = strlen($pre_match);
		
		$namespace = substr($pre_match, 0, $len-2);
		
		return $namespace;
	}
	
	/**
	* Create output
	*/
	function render($mode, &$renderer, $data) {
		if($mode == 'xhtml'){
			// $renderer->info['cache'] = FALSE;     // is this necessary? 
			// a new revision, will automatically mean a fresh copy in the cache
			$renderer->doc .= '<div>';
			$renderer->doc .= '<ol>';
			$renderer->doc .= $this->_Rethtml_top10($data);
			$renderer->doc .= '</ol>';
			$renderer->doc .= '</div>';
			return true;
		}
		return false;
	}   

	function _Rethtml_top10($namespace) {
		global $conf;
		
		ob_start();
		$dir = realpath($conf['datadir']) . '/_views/';
		$ii = 0;

		$Files = array();

		$It =  opendir($dir);
		if (! $It)
			die('No se puede listar archivos de ' . $dir);

		while ($Filename = readdir($It))
		{
			if ($Filename == '.' || $Filename == '..')
				continue;
			
			$handle = @fopen($dir."/".$Filename, "r");
			if ($handle) {
				while (!feof($handle))
				{
					$buffer = fgets($handle, 4096);
					// echo $buffer."<br>";
				}
				fclose($handle);
			}
			$expl = explode(" ", $buffer);
			if ( strlen( $namespace ) > 0){
				if (array_search($conf['start'], explode(':', urldecode($Filename))) === false &&
					strcmp(urldecode($Filename), $namespace) > 1 ) {
					$Files[$ii] = array('fichier'=>urldecode($Filename), 'nbre'=>$expl);
					$ii = $ii + 1;
				}
			} else {
				if (array_search($conf['start'], explode(':', urldecode($Filename))) === false ) {
					$Files[$ii] = array('fichier'=>urldecode($Filename), 'nbre'=>$expl);
					$ii = $ii + 1;
				}
			}
		}

		$sort_arr = array();
		foreach($Files AS $uniqid => $row){
			foreach($row AS $key=>$value){
				$sort_arr[$key][$uniqid] = $value;
			}
		}
		
		array_multisort($sort_arr['nbre'], SORT_DESC,  $Files);
		
		echo "\n";
		for($i = 0; $i <= count($Files)-1;  $i++){
			$lien = "<a href='doku.php?id=".$Files[$i]['fichier']."' class='wikilink1' style='font-weight: lighter;'>".$Files[$i]['fichier']."</a>";
			echo "", $i+1, " &rarr; ", $lien, " <sup style='font-weight: lighter;'>", $Files[$i]['nbre'][0]," views</sup><br>\n";
			if ( $i+1 > 9 )
				break;
		}
		return ob_get_clean();
	} 
}
//Setup VIM: ex: et ts=4 enc=utf-8 :
?>